Subject: Re: [Patch net] ppp: defer netns reference release for ppp channel

From: Cyrill Gorcunov <[email-masked]>
Date: Wed, 6 Jul 2016 15:25:15 +0300

On Wed, Jul 06, 2016 at 11:26:02AM +0300, Cyrill Gorcunov wrote:
> On Tue, Jul 05, 2016 at 10:12:36PM -0700, Cong Wang wrote:
> > Matt reported that we have a NULL pointer dereference
> > in ppp_pernet() from ppp_connect_channel(),
> > i.e. pch->chan_net is NULL.
> > 
> > This is due to that a parallel ppp_unregister_channel()
> > could happen while we are in ppp_connect_channel(), during
> > which pch->chan_net set to NULL. Since we need a reference
> > to net per channel, it makes sense to sync the refcnt
> > with the life time of the channel, therefore we should
> > release this reference when we destroy it.
> > 
> > Fixes: 1f461dcdd296 ("ppp: take reference on channels netns")
> > Reported-by: Matt Bennett <[email-masked]>
> > Cc: Paul Mackerras <[email-masked]>
> > Cc: [email-masked]
> > Cc: Guillaume Nault <[email-masked]>
> > Cc: Cyrill Gorcunov <[email-masked]>
> > Signed-off-by: Cong Wang <[email-masked]>
> > ---
> 
> Hi Cong! I may be wrong, but this doesn't look right in general.
> We take the net in ppp_register_channel->ppp_register_net_channel
> and (name) context implies that ppp_unregister_channel does
> the reverse. Maybe there some sync point missed? I'll review
> in detail a bit later.

After staring more I think the patch should be fine as a fix
since implementing sync with ppp_[re|un]register_channel and
ppp_ioctl might need a way more work.

Reviewed-by: Cyrill Gorcunov <[email-masked]>